dot/shell-rc: Cache whether we're running as root.
[profile] / dot / shell-rc
1 ### -*-sh-*-
2 ###
3 ### Common per-shell configuration.
4
5 ###--------------------------------------------------------------------------
6 ### Utilities.
7
8 __mdw_programp () { type >/dev/null 2>&1 "$1"; }
9
10 __mdw_source_if_exists () {
11 local i
12 for i in "$@"; do
13 if [ -r "$i" ]; then . "$i"; fi
14 done
15 }
16
17 ###--------------------------------------------------------------------------
18 ### Hooks.
19
20 __mdw_addhook () {
21 local hk=$1 fn=$2 t
22
23 eval t=\${$hk+t}
24 case $t in t) ;; *) echo >&2 "unknown hook \`$hk'"; return 2; esac
25
26 eval t=\$$hk
27 case " $t " in
28 *" $fn "*) ;;
29 *) eval "$hk=\${$hk:+\$$hk }\$fn" ;;
30 esac
31 }
32
33 __mdw_delhook () {
34 local hk=$1 fn=$2 t l r
35
36 eval t=\${$hk+t}
37 case $t in t) ;; *) echo >&2 "unknown hook \`$hk'"; return 2; esac
38
39 eval t=\" \$$hk \"
40 case $t in
41 *" $fn "*)
42 l=${t%% $fn*} r=${t##*$fn }
43 l=${l# } r=${r% }
44 eval "$hk=\$l\${l:+ }\$r"
45 ;;
46 esac
47 }
48
49 __mdw_setrc () { return $1; }
50
51 __mdw_runhook () {
52 local hk=$1 saverc=$? t i; shift
53
54 eval t=\${$hk+t}
55 case $t in t) ;; *) echo >&2 "unknown hook \`$hk'"; return 2; esac
56
57 eval t=\$$hk
58 for i in $t; do __mdw_setrc $saverc; "$i" "$@"; done
59 }
60
61 ###--------------------------------------------------------------------------
62 ### Prompt machinery.
63
64 __mdw_host=$(hostname)
65 __mdw_hqual=
66 __mdw_hqual=$__mdw_hqual${SCHROOT_CHROOT_NAME+/$SCHROOT_CHROOT_NAME}
67 __mdw_hqual=$__mdw_hqual${CROSS_BUILDENV+/$CROSS_BUILDENV}
68 __mdw_set_prompt_hacks () { host=$__mdw_host; dir=""; }
69
70 : ${USER-${LOGNAME-$(id -un)}}
71 __mdw_user=$USER
72
73 case $(id -u) in
74 0) __mdw_rootp=t ;;
75 *) __mdw_rootp=nil ;;
76 esac
77
78 __mdw_set_prompt_pieces () {
79
80 ## Fancy highlighting in some terminals.
81 local bold unbold nl gitcolour rccolour uncolour
82 local host dir more
83 bold="" unbold="" nl="" gitcolour="" rccolour="" uncolour="" more=""
84 __mdw_set_prompt_hacks
85
86 ## Choose the right delimiters. Highlight root prompts specially;
87 ## highlight when I'm running as some other user. Highlight when this
88 ## isn't the outermost shell on the terminal.
89 local left right u tty
90 case $__mdw_rootp in
91 t)
92 left=$(echo « | iconv -f UTF-8 -t //translit)
93 right=$(echo » | iconv -f UTF-8 -t //translit)
94 ;;
95 nil)
96 case $USER in
97 mdw | mwooding | nemo) u="" left="[" right="]" ;;
98 *) u="$__mdw_user@" left="{" right="}" ;;
99 esac
100 tty=$(tty)
101 case "$__mdw_tty" in
102 "$tty") left="<" right=">" ;;
103 *) __mdw_tty=$tty; export __mdw_tty ;;
104 esac
105 ;;
106 esac
107
108 ## If this session is insecure then highlight that.
109 local sec_l sec_r h
110 h=$(hostname)
111 case ${SSH_CLIENT-nil},${SCHROOT_CHROOT_NAME-nil},$__mdw_sechost in
112 nil,nil,"$h") sec_l="" sec_r="" ;;
113 nil,nil,*) sec_l="(" sec_r=")" ;;
114 *) sec_l="" sec_r=""
115 esac
116
117 ## If this is an schroot environment or some other interesting augmented
118 ## environment then point this out.
119
120 ## Put together the main pieces.
121 __mdw_prompt_left="$nl$bold$left$sec_l$u$host$__mdw_hqual$sec_r$dir"
122 __mdw_prompt_git_left="$unbold$gitcolour"
123 __mdw_prompt_git_right="$uncolour$bold"
124 __mdw_prompt_rc_left="$unbold$rccolour"
125 __mdw_prompt_rc_right="$uncolour$bold"
126 __mdw_prompt_right="$right$unbold"
127 __mdw_prompt_more=" $more$bold>$unbold "
128 }
129
130 __mdw_set_prompt () {
131 case "${TERM-dumb}:${INSIDE_EMACS+$INSIDE_EMACS}" in
132 dumb:)
133 case $(id -u) in 0) PS1='# ' ;; *) PS1='$ ' ;; esac
134 PS2='> '
135 ;;
136 *)
137 __mdw_last_rc=$?
138 local git rc
139 if type __git_ps1 >/dev/null 2>&1; then
140 git="$__mdw_prompt_git_left$(__git_ps1)$__mdw_prompt_git_right"
141 else
142 git=""
143 fi
144 case $__mdw_last_rc in
145 0) rc="" ;;
146 *) rc="$__mdw_prompt_rc_left rc=$__mdw_last_rc$__mdw_prompt_rc_right" ;;
147 esac
148 PS1="$__mdw_prompt_left$git$rc$__mdw_prompt_right"
149 PS2="$PS1$__mdw_prompt_more"
150 unset __mdw_last_rc
151 ;;
152 esac
153 }
154
155 __mdw_xterm_settitle () {
156 printf >/dev/tty \
157 "\e]2;%s@%s:%s – %s\e\\" \
158 "$__mdw_user" "$__mdw_host$__mdw_hqual" "$PWD" \
159 "$1"
160 }
161 __mdw_xterm_precmd () { __mdw_xterm_settitle "$__mdw_shell"; }
162 __mdw_xterm_preexec () { __mdw_xterm_settitle "$1"; }
163
164 __mdw_screen_settitle () {
165 printf >/dev/tty \
166 "\ek%s\e\\" \
167 "$1"
168 }
169 __mdw_screen_precmd () { __mdw_screen_settitle "$__mdw_shell"; }
170 __mdw_screen_preexec () { __mdw_screen_settitle "$1"; }
171
172 if [ -t 0 ]; then
173 case ${STY+t},${__mdw_precmd_hook+t},${__mdw_preexec_hook+t},${TERM} in
174 ,t,t,xterm*)
175 __mdw_addhook __mdw_precmd_hook __mdw_xterm_precmd
176 __mdw_addhook __mdw_preexec_hook __mdw_xterm_preexec
177 ;;
178 t,t,t,*)
179 __mdw_addhook __mdw_precmd_hook __mdw_screen_precmd
180 __mdw_addhook __mdw_preexec_hook __mdw_screen_preexec
181 ;;
182 esac
183 case ${__mdw_precmd_hook+t} in
184 t) __mdw_addhook __mdw_precmd_hook __mdw_set_prompt ;;
185 esac
186 fi
187
188 ###--------------------------------------------------------------------------
189 ### Some handy aliases.
190
191 alias cx='chmod +x'
192 alias which="command -v"
193 alias rc="rc -l"
194 rootly () {
195 case $# in 0) set -- "${SHELL-/bin/sh}" ;; esac
196 $__MDW_ROOTLY "$@"
197 }
198 alias r=rootly
199 alias re="rootly $EDITOR"
200 alias pstree="pstree -hl"
201 alias cdtmp='cd ${TMPDIR-/tmp}'
202 alias pushtmp='pushd ${TMPDIR-/tmp}'
203 alias e="$EDITOR"
204 alias svn="svnwrap svn"
205 alias @="ssh"
206 alias make="nice make"
207 alias cross-run="nice cross-run"
208 alias gdb="gdb -q"
209
210 ###--------------------------------------------------------------------------
211 ### Colour output.
212
213 ## Arrange for `ls' output to be in colour.
214 if __mdw_programp dircolors; then eval $(dircolors -b "$HOME/.dircolors")
215 else unset LS_COLORS; fi
216
217 unalias ls 2>/dev/null || :
218 ls () {
219 if [ -t 1 ]; then command ls $LS_OPTIONS ${LS_COLORS+--color=auto} "$@"
220 else command ls "$@"; fi
221 }
222
223 ## Arrange for `grep' output to be in colour.
224 export GREP_COLORS="mt=01;31:ms=01;31:mc=031;31:fn=36:ln=36:bn=36:se=34"
225
226 greplike () {
227 local grep=$1; shift
228 if [ -t 1 ]; then
229 command $grep ${GREP_COLORS+--color=always} "$@" | mdw-pager
230 else
231 command $grep "$@"
232 fi
233 }
234 alias grep="greplike grep"
235 alias egrep="greplike egrep"
236 alias fgrep="greplike fgrep"
237 alias zgrep="greplike zgrep"
238
239 ## Arrange for `diff' output to be in colour.
240 export DIFF_COLORS="hd=1:ln=36:ad=32:de=31"
241 difflike () {
242 local diff=$1; shift
243 if [ -t 1 ]; then
244 command $diff \
245 ${DIFF_COLORS+--color=always} \
246 ${DIFF_COLORS+--palette="$DIFF_COLORS"} \
247 "$@" | mdw-pager
248 else
249 command $diff "$@" | cat
250 fi
251 }
252 alias diff="difflike diff"
253
254 ###--------------------------------------------------------------------------
255 ### Other hacks.
256
257 ## Turn off pagers inside Emacs shell buffers.
258 case "$INSIDE_EMACS" in
259 2[2-9].*,comint | [3-9][0-9].*,comint) export PAGER=cat ;;
260 esac
261
262 ###--------------------------------------------------------------------------
263 ### More complicated shell functions.
264
265 ## xt [@HOST] XTERM-ARGS
266 ##
267 ## Open a terminal, maybe on a remote host.
268 xt () {
269 case "$1" in
270 @*)
271 local remote=${1#@} title
272 shift
273 if [ $# -gt 0 ]; then
274 title="xterm [$remote] $1"
275 else
276 title="xterm [$remote]"
277 fi
278 (xterm -title "$title" -e ssh $remote "$@" &)
279 ;;
280 *)
281 (xterm "$@" &)
282 ;;
283 esac
284 }
285
286 ## core [y|n]
287 ##
288 ## Tweak core dumps on and off, or show the current status.
289 core () {
290 case "x$1" in
291 xon|xy|xyes) ulimit -Sc $(ulimit -Hc) ;;
292 xoff|xn|xno) ulimit -Sc 0 ;;
293 x)
294 local l=$(ulimit -Sc)
295 case $l in
296 0) echo "Core dumps disabled" ;;
297 unlimited) echo "Core dumps enabled" ;;
298 *) echo "Core dump limit is $l blocks" ;;
299 esac
300 ;;
301 *)
302 echo >&2 "usage: core [y|n]"
303 return 1
304 ;;
305 esac
306 }
307
308 ## world [NAME]
309 ##
310 ## Set current security world to NAME. With no NAME, print the currently
311 ## selected world.
312 world () {
313 local nfast=${NFAST_HOME-/opt/nfast}
314 local kmdata
315 case "$#" in
316 0)
317 echo "${NFAST_KMDATA#$nfast/kmdata-}"
318 ;;
319 *)
320 if [ -d "$1" ]; then
321 kmdata=$1
322 elif [ -d "$nfast/kmdata-$1" ]; then
323 kmdata=$nfast/kmdata-$1
324 else
325 echo >&2 "world: can't find world $1"
326 return 1
327 fi
328 shift
329 case "$#" in
330 0) export NFAST_KMDATA=$kmdata ;;
331 *) "$@" ;;
332 esac
333 ;;
334 esac
335 }
336
337 ## path-add [VAR] DIR
338 ##
339 ## Add DIR to the beginning of PATH-like variable VAR (defaults to PATH) if
340 ## it's not there already.
341 path_add () {
342 local pathvar export dir val
343 case $# in
344 1) pathvar=PATH dir=$1 export="export PATH" ;;
345 2) pathvar=$1 dir=$2 export=: ;;
346 *) echo >&2 "Usage: $0 [VAR] DIR"; return 1 ;;
347 esac
348 eval val=\$$pathvar
349 case ":$val:" in
350 *:"$dir":*) ;;
351 *) val=$dir:$val ;;
352 esac
353 eval $pathvar=\$val
354 eval $export
355 }
356
357 ## path-remove [VAR] DIR
358 ##
359 ## Remove DIR from PATH-like variable VAR (defaults to PATH); it's not an
360 ## error if DIR isn't in VAR.
361 path_remove () {
362 local pathvar export dir val
363 case $# in
364 1) pathvar=PATH dir=$1 export="export PATH" ;;
365 2) pathvar=$1 dir=$2 export=: ;;
366 *) echo >&2 "Usage: $0 [VAR] DIR"; return 1 ;;
367 esac
368 eval val=\$$pathvar
369 case ":$val:" in
370 :"$dir":) val= ;;
371 :"$dir":*) val=${val#$dir:} ;;
372 *:"$dir":) val=${val%:$dir} ;;
373 *:"$dir":*) val=${val%%:$dir:*}:${val#*:$dir:} ;;
374 esac
375 eval $pathvar=\$val
376 eval $export
377 }
378
379 ## pathhack [-f] +HACK|-HACK...
380 ##
381 ## Each HACK refers to a subdirectory of `~/bin/hacks'. A hack name preceded
382 ## by `+' adds the directory to the PATH; a `-' removes. Adding a hack
383 ## that's already on the PATH doesn't do anything unless `-f' is set, in
384 ## which case it gets moved to the beginning. With no arguments, print the
385 ## currently installed hacks.
386 pathhack () {
387 local p e force arg hack dir
388 p=$PATH
389 if [ $# -eq 0 ]; then
390 while :; do
391 e=${p%%:*}
392 case "$e" in "$HOME/bin/hacks/"*) echo ${e#$HOME/bin/hacks/} ;; esac
393 case "$p" in *:*) p=${p#*:} ;; *) break ;; esac
394 done
395 return
396 fi
397 force=nil
398 while [ $# -gt 0 ]; do
399 arg=$1
400 case "$arg" in
401 -f | --force) force=t; shift; continue ;;
402 --) shift; break ;;
403 [-+]*) ;;
404 *) break; ;;
405 esac
406 hack=${arg#[+-]}
407 dir=$HOME/bin/hacks/$hack
408 if ! [ -d "$dir" ]; then
409 echo "$0: path hack $hack not found"
410 return 1
411 fi
412 case "$arg,$force,:$PATH:" in
413 -*,*,*:"$dir":*) path_remove p "$dir" ;;
414 +*,t,*:"$dir":*) path_remove p "$dir"; path_add p "$dir" ;;
415 +*,nil,*:"$dir":*) ;;
416 +*,*) path_add p "$dir" ;;
417 esac
418 shift
419 done
420 if [ $# -eq 0 ]; then PATH=$p; export PATH
421 else PATH=$p "$@"; fi
422 }
423
424 ###--------------------------------------------------------------------------
425 ### Finishing touches.
426
427 ## Make sure `$HOME/bin' is on the path.
428 path_add "$HOME/bin"
429
430 ## Set the temporary directory again. (A setuid or setgid program may have
431 ## unhelpfully forgotten this for us.)
432 case ${TMPDIR+t} in
433 t) ;;
434 *) if __mdw_programp tmpdir; then eval $(tmpdir -b); fi ;;
435 esac
436
437 ## For `root' use -- some simple molly-guards.
438 case $(id -u) in
439 0)
440 alias rm="rm -i" cp="cp -i" mv="mv -i"
441 set -o noclobber
442 ;;
443 esac
444
445 ## Run any local hooks.
446 __mdw_source_if_exists "$HOME/.shell-local"
447
448 ###----- That's all, folks --------------------------------------------------